/* function.c - Script 10.5 */

#include <stdio.h>
#include <stdlib.h>
#include <assert.h>

/* Function prototype for function */
char *get_name(void);

int main (void) {

	/* Define a char pointer variable
	 * to hold the base address of an array of
	 * chars, i.e. a string. */
	char *name = NULL;

	/* Call the subroutine and store the address
	 * value it returns into the pointer variable */
	name = get_name();
	
	/* check for success and abort upon failure */
	assert(name != NULL);
	
	printf("Name: %s\n", name);

	/* Return the block to the pool */
	free(name);
	name = NULL;

	/* Pause and wait for input before terminating */
	getchar();

	return 0;

} /* End of main() function. */



/* This function asks for a name of arbitrary
 * length and returns a pointer to the character
 * array with the name. */
char *get_name(void) {

	int size = 10, index = 0;
	char inputchar;
	
	/* allocate a memory block of the initial size */
	char *input = malloc(size);
	char *temp = NULL;

	/* check if the allocation succeeded */
	if (input == NULL) {
		printf("Unable to allocate memory!\n");
		return NULL;
	}

	/* prompt the user for input */
	printf("Enter your name: ");

	while ((inputchar = getchar()) != '\n') {
	
		if (index == size - 1) {
			size *= 1.5;
			temp = realloc(input, size);
			if (temp != NULL) {
				input = temp;
			} else {
				input[index] = '\0';
				return input;
			}
		}
		
		input[index] = inputchar;
		index++;
	}

	input[index] = '\0';

	/* return the address of the memory block */
	return input;

}




/* This function asks for a name and returns
 * a pointer to the character array with the name. */
char *get_name2(void) {

	/* allocate a memory block 100 bytes long */
	char *input = malloc(100);
	
	/* check if the allocation succeeded */
	if (input == NULL) {
		printf("Unable to allocate memory!\n");
		return NULL;
	}
	
	/* prompt the user for input */
	printf("Enter your name: ");

	/* store the input into our memory block */
	scanf("%99s", input);
	
	/* return the address of the memory block */
	return input;

}


